/*
 *  Copyright 2007-2013, Plutext Pty Ltd.
 *   
 *  This file is part of docx4j.

    docx4j is licensed under the Apache License, Version 2.0 (the "License"); 
    you may not use this file except in compliance with the License. 

    You may obtain a copy of the License at 

        http://www.apache.org/licenses/LICENSE-2.0 

    Unless required by applicable law or agreed to in writing, software 
    distributed under the License is distributed on an "AS IS" BASIS, 
    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
    See the License for the specific language governing permissions and 
    limitations under the License.

 */


package org.docx4j.wml; 

import org.jvnet.jaxb2_commons.ppp.Child;

import javax.xml.bind.Unmarshaller;
import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlRootElement;
import javax.xml.bind.annotation.XmlTransient;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for anonymous complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType>
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="rPrDefault" minOccurs="0">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                 &lt;sequence>
 *                   &lt;element name="rPr" type="{http://schemas.openxmlformats.org/wordprocessingml/2006/main}CT_RPr" minOccurs="0"/>
 *                 &lt;/sequence>
 *               &lt;/restriction>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *         &lt;element name="pPrDefault" minOccurs="0">
 *           &lt;complexType>
 *             &lt;complexContent>
 *               &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *                 &lt;sequence>
 *                   &lt;element name="pPr" type="{http://schemas.openxmlformats.org/wordprocessingml/2006/main}CT_PPr" minOccurs="0"/>
 *                 &lt;/sequence>
 *               &lt;/restriction>
 *             &lt;/complexContent>
 *           &lt;/complexType>
 *         &lt;/element>
 *       &lt;/sequence>
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "", propOrder = {
    "rPrDefault",
    "pPrDefault"
})
@XmlRootElement(name = "docDefaults")
public class DocDefaults
{

    protected DocDefaults.RPrDefault rPrDefault;
    protected DocDefaults.PPrDefault pPrDefault;

    /**
     * Gets the value of the rPrDefault property.
     * 
     * @return
     *     possible object is
     *     {@link DocDefaults.RPrDefault }
     *     
     */
    public DocDefaults.RPrDefault getRPrDefault(boolean forceCreate) {
    	if(rPrDefault==null&&forceCreate) {
    		rPrDefault = new RPrDefault();
    	}
        return rPrDefault;
    }

    /**
     * Sets the value of the rPrDefault property.
     * 
     * @param value
     *     allowed object is
     *     {@link DocDefaults.RPrDefault }
     *     
     */
    public void setRPrDefault(DocDefaults.RPrDefault value) {
        this.rPrDefault = value;
    }

    /**
     * Gets the value of the pPrDefault property.
     * 
     * @return
     *     possible object is
     *     {@link DocDefaults.PPrDefault }
     *     
     */
    public DocDefaults.PPrDefault getPPrDefault() {
        return pPrDefault;
    }

    /**
     * Sets the value of the pPrDefault property.
     * 
     * @param value
     *     allowed object is
     *     {@link DocDefaults.PPrDefault }
     *     
     */
    public void setPPrDefault(DocDefaults.PPrDefault value) {
        this.pPrDefault = value;
    }

    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *       &lt;sequence>
     *         &lt;element name="pPr" type="{http://schemas.openxmlformats.org/wordprocessingml/2006/main}CT_PPr" minOccurs="0"/>
     *       &lt;/sequence>
     *     &lt;/restriction>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "pPr"
    })
    public static class PPrDefault implements Child
    {

        protected PPr pPr;
        @XmlTransient
        private Object parent;

        /**
         * Gets the value of the pPr property.
         * 
         * @return
         *     possible object is
         *     {@link PPr }
         *     
         */
        public PPr getPPr() {
            return pPr;
        }

        /**
         * Sets the value of the pPr property.
         * 
         * @param value
         *     allowed object is
         *     {@link PPr }
         *     
         */
        public void setPPr(PPr value) {
            this.pPr = value;
        }

        /**
         * Gets the parent object in the object tree representing the unmarshalled xml document.
         * 
         * @return
         *     The parent object.
         */
        public Object getParent() {
            return this.parent;
        }

        public void setParent(Object parent) {
            this.parent = parent;
        }

        /**
         * This method is invoked by the JAXB implementation on each instance when unmarshalling completes.
         * 
         * @param parent
         *     The parent object in the object tree.
         * @param unmarshaller
         *     The unmarshaller that generated the instance.
         */
        public void afterUnmarshal(Unmarshaller unmarshaller, Object parent) {
            setParent(parent);
        }

    }


    /**
     * <p>Java class for anonymous complex type.
     * 
     * <p>The following schema fragment specifies the expected content contained within this class.
     * 
     * <pre>
     * &lt;complexType>
     *   &lt;complexContent>
     *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
     *       &lt;sequence>
     *         &lt;element name="rPr" type="{http://schemas.openxmlformats.org/wordprocessingml/2006/main}CT_RPr" minOccurs="0"/>
     *       &lt;/sequence>
     *     &lt;/restriction>
     *   &lt;/complexContent>
     * &lt;/complexType>
     * </pre>
     * 
     * 
     */
    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
        "rPr"
    })
    public static class RPrDefault implements Child
    {

        protected RPr rPr;
        @XmlTransient
        private Object parent;

        /**
         * Gets the value of the rPr property.
         * 
         * @return
         *     possible object is
         *     {@link RPr }
         *     
         */
        public RPr getRPr(boolean forceCreate) {
        	if(rPr==null&&forceCreate) {
        		rPr = new RPr();
        	}
            return rPr;
        }

        /**
         * Sets the value of the rPr property.
         * 
         * @param value
         *     allowed object is
         *     {@link RPr }
         *     
         */
        public void setRPr(RPr value) {
            this.rPr = value;
        }

        /**
         * Gets the parent object in the object tree representing the unmarshalled xml document.
         * 
         * @return
         *     The parent object.
         */
        public Object getParent() {
            return this.parent;
        }

        public void setParent(Object parent) {
            this.parent = parent;
        }

        /**
         * This method is invoked by the JAXB implementation on each instance when unmarshalling completes.
         * 
         * @param parent
         *     The parent object in the object tree.
         * @param unmarshaller
         *     The unmarshaller that generated the instance.
         */
        public void afterUnmarshal(Unmarshaller unmarshaller, Object parent) {
            setParent(parent);
        }

    }

}
