/*
 *
 *    OPEN-XCHANGE legal information
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *
 *    In some countries OX, OX Open-Xchange, open xchange and OXtender
 *    as well as the corresponding Logos OX Open-Xchange and OX are registered
 *    trademarks.
 *    The use of the Logos is not covered by the GNU General Public License.
 *    Instead, you are allowed to use these Logos according to the terms and
 *    conditions of the Creative Commons License, Version 2.5, Attribution,
 *    Non-commercial, ShareAlike, and the interpretation of the term
 *    Non-commercial applicable to the aforementioned license is published
 *    on the web site http://www.open-xchange.com/EN/legal/index.html.
 *
 *    Please make sure that third-party modules and libraries are used
 *    according to their respective licenses.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original and derivative code shall remain
 *    under the copyright of the copyright holder(s) and/or original author(s)per
 *    the Attribution and Assignment Agreement that can be located at
 *    http://www.open-xchange.com/EN/developer/. The contributing author shall be
 *    given Attribution for the derivative code and a license granting use.
 *
 *     Copyright (C) 2016 OX Software GmbH
 *     Mail: info@open-xchange.com
 *
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License, Version 2 as published
 *     by the Free Software Foundation.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

package org.xlsx4j.schemas.microsoft.com.office.spreadsheetml_2009_9.main;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlAttribute;
import javax.xml.bind.annotation.XmlType;


/**
 * <p>Java class for CT_CacheHierarchy complex type.
 * 
 * <p>The following schema fragment specifies the expected content contained within this class.
 * 
 * <pre>
 * &lt;complexType name="CT_CacheHierarchy">
 *   &lt;complexContent>
 *     &lt;restriction base="{http://www.w3.org/2001/XMLSchema}anyType">
 *       &lt;sequence>
 *         &lt;element name="setLevels" type="{http://schemas.microsoft.com/office/spreadsheetml/2009/9/main}CT_SetLevels" minOccurs="0"/>
 *       &lt;/sequence>
 *       &lt;attribute name="flattenHierarchies" type="{http://www.w3.org/2001/XMLSchema}boolean" default="true" />
 *       &lt;attribute name="measuresSet" type="{http://www.w3.org/2001/XMLSchema}boolean" default="false" />
 *       &lt;attribute name="hierarchizeDistinct" type="{http://www.w3.org/2001/XMLSchema}boolean" default="true" />
 *       &lt;attribute name="ignore" type="{http://www.w3.org/2001/XMLSchema}boolean" default="false" />
 *     &lt;/restriction>
 *   &lt;/complexContent>
 * &lt;/complexType>
 * </pre>
 * 
 * 
 */
@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "CT_CacheHierarchy", propOrder = {
    "setLevels"
})
public class CTCacheHierarchy {

    protected CTSetLevels setLevels;
    @XmlAttribute(name = "flattenHierarchies")
    protected Boolean flattenHierarchies;
    @XmlAttribute(name = "measuresSet")
    protected Boolean measuresSet;
    @XmlAttribute(name = "hierarchizeDistinct")
    protected Boolean hierarchizeDistinct;
    @XmlAttribute(name = "ignore")
    protected Boolean ignore;

    /**
     * Gets the value of the setLevels property.
     * 
     * @return
     *     possible object is
     *     {@link CTSetLevels }
     *     
     */
    public CTSetLevels getSetLevels() {
        return setLevels;
    }

    /**
     * Sets the value of the setLevels property.
     * 
     * @param value
     *     allowed object is
     *     {@link CTSetLevels }
     *     
     */
    public void setSetLevels(CTSetLevels value) {
        this.setLevels = value;
    }

    /**
     * Gets the value of the flattenHierarchies property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isFlattenHierarchies() {
        if (flattenHierarchies == null) {
            return true;
        } else {
            return flattenHierarchies;
        }
    }

    /**
     * Sets the value of the flattenHierarchies property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setFlattenHierarchies(Boolean value) {
        this.flattenHierarchies = value;
    }

    /**
     * Gets the value of the measuresSet property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isMeasuresSet() {
        if (measuresSet == null) {
            return false;
        } else {
            return measuresSet;
        }
    }

    /**
     * Sets the value of the measuresSet property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setMeasuresSet(Boolean value) {
        this.measuresSet = value;
    }

    /**
     * Gets the value of the hierarchizeDistinct property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isHierarchizeDistinct() {
        if (hierarchizeDistinct == null) {
            return true;
        } else {
            return hierarchizeDistinct;
        }
    }

    /**
     * Sets the value of the hierarchizeDistinct property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setHierarchizeDistinct(Boolean value) {
        this.hierarchizeDistinct = value;
    }

    /**
     * Gets the value of the ignore property.
     * 
     * @return
     *     possible object is
     *     {@link Boolean }
     *     
     */
    public boolean isIgnore() {
        if (ignore == null) {
            return false;
        } else {
            return ignore;
        }
    }

    /**
     * Sets the value of the ignore property.
     * 
     * @param value
     *     allowed object is
     *     {@link Boolean }
     *     
     */
    public void setIgnore(Boolean value) {
        this.ignore = value;
    }

}
